"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
/**
 * Given a SharedCell will produce a collaborative checkbox.
 */
class CollaborativeCheckbox extends react_1.default.Component {
    constructor(props) {
        super(props);
        this.state = {
            checked: this.isChecked(),
        };
        this.updateCheckbox = this.updateCheckbox.bind(this);
        this.isChecked = this.isChecked.bind(this);
    }
    componentDidMount() {
        // Register a callback for when the value changes
        this.props.data.on("valueChanged", () => {
            const checked = this.isChecked();
            this.setState({ checked });
        });
    }
    render() {
        return (react_1.default.createElement("input", { type: "checkbox", className: this.props.className, style: this.props.style, "aria-checked": this.state.checked, name: this.props.id, checked: this.state.checked, onChange: this.updateCheckbox }));
    }
    updateCheckbox(e) {
        this.props.data.set(e.target.checked);
    }
    isChecked() {
        var _a;
        return _a = this.props.data.get(), (_a !== null && _a !== void 0 ? _a : false);
    }
}
exports.CollaborativeCheckbox = CollaborativeCheckbox;
//# sourceMappingURL=CollaborativeCheckbox.js.map